/*
 * Copyright 1999-2018 Alibaba Group Holding Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.alibaba.druid.bvt.filter.wall.sqlserver;

import junit.framework.TestCase;

import org.junit.Assert;

import com.alibaba.druid.wall.WallProvider;
import com.alibaba.druid.wall.spi.SQLServerWallProvider;

/**
 * SQLServerWallTest
 * 
 * @see
 */
public class SQLServerWallTest_9 extends TestCase {

    public void test_true() throws Exception {
        WallProvider provider = new SQLServerWallProvider();

        String sql = "SELECT s.id FROM snapshots s " //
                     + "WHERE s.scope='PRJ'"//
                     + " and s.qualifier IN ('TRK', 'BRC')"//
                     + " AND status='P'" //
                     + " AND islast=0" //
                     + " AND NOT EXISTS (select m.id from project_measures m WHERE m.snapshot_id=s.id)";

        Assert.assertTrue(provider.checkValid(sql));

    }

}
